/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_DB
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 1 "bi_db.m4"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2006, 2007, 2008 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#define LOOKUP_NULL_BYTE 0x1
#define LOOKUP_TEST_ONLY 0x2

static int
dbmap_lookup(eval_environ_t env, char *dbname, const char *keystr,
	     const char *defval, int flags)
{
	int rc;
	DBM_FILE db;
	DBM_DATUM key;
	DBM_DATUM contents;

	if (!defval)
		defval = "";
	if (mu_dbm_open(dbname, &db, MU_STREAM_READ, 0, NULL))
			env_throw_bi(env, mf_dbfailure, NULL, _("mu_dbm_open(%s) failed: %s"),dbname,mu_dbm_strerror());
#line 36

	memset(&key, 0, sizeof key);
	memset(&contents, 0, sizeof contents);
	MU_DATUM_PTR(key) = (void*) keystr;
	MU_DATUM_SIZE(key) = strlen(keystr);
	if (flags & LOOKUP_NULL_BYTE)
		MU_DATUM_SIZE(key)++;
	rc = mu_dbm_fetch(&db, key, &contents) == 0;
	debug2(10, "Looking up %s: %s", keystr, rc ? "true" : "false");
	if (flags & LOOKUP_TEST_ONLY) 
		push(env, (STKVAL)rc);
	else {
		if (!rc) {
			if (defval)
				pushs(env, (STKVAL)defval);
			else
				push(env, 0);
		} else if (((char*)MU_DATUM_PTR(contents))[MU_DATUM_SIZE(contents)-1]) {
			size_t off;
			size_t len = MU_DATUM_SIZE(contents);
			char *s = (char*) env_data_ref(env, (off = heap_reserve(env, len + 1)));
			memcpy(s, MU_DATUM_PTR(contents), len);
			s[len] = 0;
			push(env, (STKVAL) off);
		} else
			pushs(env, MU_DATUM_PTR(contents));
	}
	mu_dbm_datum_free(&contents);
	mu_dbm_close(&db);
	return rc;
}

void
#line 68
bi_dbmap(eval_environ_t env)
#line 68

#line 68 "bi_db.m4"
{
#line 68
	
#line 68

#line 68
long __bi_argcnt = (long)get_numeric_arg(env, 0);
#line 68
char * dbname = (char *) get_string_arg(env, 1);
#line 68
        char * key = (char *) get_string_arg(env, 2);
#line 68
        long  null = (long ) get_numeric_arg(env, 3);
#line 68
        
#line 68
        adjust_stack(env, __bi_argcnt + 1);
#line 68

#line 68
	if (prog_trace_option & BUILTIN_MASK_db)
#line 68
		prog_trace(env, "dbmap %s %s %lu",dbname, key, ((__bi_argcnt > 2) ? null : 0));;
#line 68

{
	dbmap_lookup(env, dbname, key, NULL,
		     LOOKUP_TEST_ONLY | 
                        (((__bi_argcnt > 2) ? null : 0) ? LOOKUP_NULL_BYTE : 0));
}
}

void
#line 76
bi_dbget(eval_environ_t env)
#line 76

#line 76 "bi_db.m4"
{
#line 76
	
#line 76

#line 76
long __bi_argcnt = (long)get_numeric_arg(env, 0);
#line 76
char * dbname = (char *) get_string_arg(env, 1);
#line 76
        char * key = (char *) get_string_arg(env, 2);
#line 76
        char * defval = (char *) get_string_arg(env, 3);
#line 76
        long  null = (long ) get_numeric_arg(env, 4);
#line 76
        
#line 76
        adjust_stack(env, __bi_argcnt + 1);
#line 76

#line 76
	if (prog_trace_option & BUILTIN_MASK_db)
#line 76
		prog_trace(env, "dbget %s %s %s %lu",dbname, key, ((__bi_argcnt > 2) ? defval : ""), ((__bi_argcnt > 3) ? null : 0));;

{
	dbmap_lookup(env, dbname, key, 
                     ((__bi_argcnt > 2) ? defval : 0), 
                     (((__bi_argcnt > 3) ? null : 0) ? LOOKUP_NULL_BYTE : 0));
}
}

void
#line 85
bi_dbput(eval_environ_t env)
#line 85

#line 85 "bi_db.m4"
{
#line 85
	
#line 85

#line 85
long __bi_argcnt = (long)get_numeric_arg(env, 0);
#line 85
char * dbname = (char *) get_string_arg(env, 1);
#line 85
        char * keystr = (char *) get_string_arg(env, 2);
#line 85
        char * value = (char *) get_string_arg(env, 3);
#line 85
        long  null = (long ) get_numeric_arg(env, 4);
#line 85
        
#line 85
        adjust_stack(env, __bi_argcnt + 1);
#line 85

#line 85
	if (prog_trace_option & BUILTIN_MASK_db)
#line 85
		prog_trace(env, "dbput %s %s %s %lu",dbname, keystr, value, ((__bi_argcnt > 3) ? null : 0));;

{
	int rc;
	DBM_FILE db;
	DBM_DATUM key;
	DBM_DATUM contents;
	
	if (mu_dbm_open(dbname, &db, MU_STREAM_RDWR, 0640, NULL))
			env_throw_bi(env, mf_dbfailure, "dbput", _("mu_dbm_open(%s) failed: %s"),dbname,mu_dbm_strerror());
#line 98
	memset(&key, 0, sizeof key);
	MU_DATUM_PTR(key) = keystr;
	MU_DATUM_SIZE(key) = strlen(keystr);
	if (((__bi_argcnt > 3) ? null : 0))
		MU_DATUM_SIZE(key)++;

	memset(&contents, 0, sizeof contents);
	MU_DATUM_PTR(contents) = value;
	MU_DATUM_SIZE(contents) = strlen(value) + 1;
	
	rc = mu_dbm_insert(&db, key, contents, 1);
	mu_dbm_close(&db);
		if (!(rc == 0))
#line 110
			env_throw_bi(env, mf_dbfailure, "dbput", _("Failed to insert data to %s: %s %s: %s"),dbname,keystr,value,mu_dbm_strerror())
#line 116
;
}
}

void
#line 120
bi_dbdel(eval_environ_t env)
#line 120

#line 120 "bi_db.m4"
{
#line 120
	
#line 120

#line 120
long __bi_argcnt = (long)get_numeric_arg(env, 0);
#line 120
char * dbname = (char *) get_string_arg(env, 1);
#line 120
        char * keystr = (char *) get_string_arg(env, 2);
#line 120
        long  null = (long ) get_numeric_arg(env, 3);
#line 120
        
#line 120
        adjust_stack(env, __bi_argcnt + 1);
#line 120

#line 120
	if (prog_trace_option & BUILTIN_MASK_db)
#line 120
		prog_trace(env, "dbdel %s %s %lu",dbname, keystr, ((__bi_argcnt > 2) ? null : 0));;
#line 120

{
	DBM_FILE db;
	DBM_DATUM key;
	int rc;	
	if (mu_dbm_open(dbname, &db, MU_STREAM_RDWR, 0640, NULL))
			env_throw_bi(env, mf_dbfailure, "dbdel", _("mu_dbm_open(%s) failed: %s"),dbname,mu_dbm_strerror());
#line 130
	memset(&key, 0, sizeof key);
	MU_DATUM_PTR(key) = keystr;
	MU_DATUM_SIZE(key) = strlen(keystr);
	if (((__bi_argcnt > 2) ? null : 0))
		MU_DATUM_SIZE(key)++;
	rc = mu_dbm_delete(&db, key);
	mu_dbm_close(&db);
		if (!(rc == 0))
#line 137
			env_throw_bi(env, mf_dbfailure, "dbdel", _("Failed to delete data `%s' from `%s': %s"),keystr,dbname,mu_dbm_strerror())
#line 142
;
}
}


static void
greylist_print_item(const char *key, size_t size, const void *content)
{
	time_t timestamp = *(time_t*) content;
	size--; /* Size includes the trailing nul */
	printf("%*.*s ", size, size, key);
	format_time_str(stdout, timestamp);
	putchar('\n');
}

static int
greylist_expire_item(const void *content)
{
	time_t timestamp = *(time_t*) content;
	return greylist_format->expire_interval &&
		time(NULL) - timestamp > greylist_format->expire_interval;
}


static struct db_format greylist_format_struct = {
	"greylist",
	DEFAULT_GREYLIST_DATABASE,
	1,
	DEFAULT_EXPIRE_INTERVAL,
	greylist_print_item,
	greylist_expire_item
};

struct db_format *greylist_format = &greylist_format_struct;

static size_t greylist_seconds_left_loc
#line 177 "bi_db.m4"
;

/* greylist(key, interval)

   Returns true if the key is greylisted, false if it's OK to
   deliver mail.
 */
void
#line 184
bi_greylist(eval_environ_t env)
#line 184

#line 184 "bi_db.m4"
{
#line 184
	
#line 184

#line 184

#line 184
char * email = (char *) get_string_arg(env, 0);
#line 184
        long  interval = (long ) get_numeric_arg(env, 1);
#line 184
        
#line 184
        adjust_stack(env, 2);
#line 184

#line 184
	if (prog_trace_option & BUILTIN_MASK_db)
#line 184
		prog_trace(env, "greylist %s %lu",email, interval);;
#line 184

{
	int rc;
	DBM_FILE db;
	DBM_DATUM key;
	DBM_DATUM contents;
	int readonly;
	time_t now;

	rc = mu_dbm_open(greylist_format->dbname, &db, MU_STREAM_RDWR, 0600,
			 &readonly);
        	if (!(rc == 0))
#line 195
			env_throw_bi(env, mf_dbfailure, "greylist", _("mu_dbm_open(%s) failed: %s"),greylist_format->dbname,mu_dbm_strerror())
;
	
	memset(&key, 0, sizeof key);
	memset(&contents, 0, sizeof contents);
	MU_DATUM_PTR(key) = email;
	MU_DATUM_SIZE(key) = strlen(email)+1;

	time(&now);
	if (mu_dbm_fetch(&db, key, &contents) == 0) {
		time_t timestamp, diff;

			if (!(MU_DATUM_SIZE(contents) == sizeof timestamp))
#line 207
			env_throw_bi(env, mf_dbfailure, "greylist", _("Greylist database %s has wrong data size"),greylist_format->dbname)
#line 210
;
		
		timestamp = *(time_t*) MU_DATUM_PTR(contents);
		diff = now - timestamp;
	
		__DBG(20) {
			char timebuf[32];
			debug_log("%s entered greylist database on %s, "
				  "%ld seconds ago",
				  email,
				  mailfromd_timestr(timestamp, timebuf,
						    sizeof timebuf),
				  (long) diff);
		}

		if (diff < interval) {
			diff = interval - diff;

			*env_data_ref(env, greylist_seconds_left_loc) = (STKVAL) (diff);
			
			debug2(20, "%s still greylisted (for %lu sec.)",
			       email,
			       (unsigned long) diff);
			rc = 1;
		} else if (diff > greylist_format->expire_interval) {
			debug1(20, "greylist record for %s expired",
			       email);
			if (!readonly) {
				memcpy(MU_DATUM_PTR(contents),
				       &now, sizeof now);
				if (mu_dbm_insert(&db, key, contents, 1))
					mu_error(_("Cannot insert datum `%-.*s' in "
						   "greylist database %s: %s"),
			                         MU_DATUM_SIZE(key),
						 (char*)MU_DATUM_PTR(key),
						 greylist_format->dbname,
	                                         mu_dbm_strerror());
			} else
				debug(20, "database opened in readonly mode: "
				      "not updating");
			rc = 1;
		} else {
			debug1(20, "%s finished greylisting period",
			       email);
			rc = 0;
		}
		mu_dbm_datum_free(&contents);
	} else if (!readonly) {
		debug1(20, "greylisting %s", email);
		*env_data_ref(env, greylist_seconds_left_loc) = (STKVAL) (interval);
		MU_DATUM_PTR(contents) = (void*)&now;
		MU_DATUM_SIZE(contents) = sizeof now;
		if (mu_dbm_insert(&db, key, contents, 1))
			mu_error(_("Cannot insert datum `%-.*s' in greylist "
				   "database %s: %s"),
		                 MU_DATUM_SIZE(key), (char*)MU_DATUM_PTR(key),
				 greylist_format->dbname,
	                         mu_dbm_strerror());
		rc = 1;
	} else
		rc = 0;

	mu_dbm_close(&db);

	
#line 274
do {
#line 274
  push(env, (STKVAL) (rc));
#line 274
  return;
#line 274
} while (0);
}
}

void
#line 278
bi_db_name(eval_environ_t env)
#line 278

#line 278 "bi_db.m4"
{
#line 278
	
#line 278

#line 278

#line 278
char * fmtid = (char *) get_string_arg(env, 0);
#line 278
        
#line 278
        adjust_stack(env, 1);
#line 278

#line 278
	if (prog_trace_option & BUILTIN_MASK_db)
#line 278
		prog_trace(env, "db_name %s",fmtid);;
#line 278

{
	struct db_format *fmt = db_format_lookup(fmtid);
		if (!(fmt != NULL))
#line 281
			env_throw_bi(env, mf_not_found, "db_name", _("No such db format: %s"),fmtid)
#line 283
;
	do {pushs(env, fmt->dbname);
#line 284
return;
#line 284
} while (0);
}
}

void
#line 288
bi_db_get_active(eval_environ_t env)
#line 288

#line 288 "bi_db.m4"
{
#line 288
	
#line 288

#line 288

#line 288
char * fmtid = (char *) get_string_arg(env, 0);
#line 288
        
#line 288
        adjust_stack(env, 1);
#line 288

#line 288
	if (prog_trace_option & BUILTIN_MASK_db)
#line 288
		prog_trace(env, "db_get_active %s",fmtid);;
#line 288

{
	struct db_format *fmt = db_format_lookup(fmtid);
		if (!(fmt != NULL))
#line 291
			env_throw_bi(env, mf_not_found, "db_get_active", _("No such db format: %s"),fmtid)
#line 293
;
	
#line 294
do {
#line 294
  push(env, (STKVAL) (fmt->enabled));
#line 294
  return;
#line 294
} while (0);
}
}

void
#line 298
bi_db_set_active(eval_environ_t env)
#line 298

#line 298 "bi_db.m4"
{
#line 298
	
#line 298

#line 298

#line 298
char * fmtid = (char *) get_string_arg(env, 0);
#line 298
        long  active = (long ) get_numeric_arg(env, 1);
#line 298
        
#line 298
        adjust_stack(env, 2);
#line 298

#line 298
	if (prog_trace_option & BUILTIN_MASK_db)
#line 298
		prog_trace(env, "db_set_active %s %lu",fmtid, active);;
#line 298

{
	struct db_format *fmt = db_format_lookup(fmtid);
		if (!(fmt != NULL))
#line 301
			env_throw_bi(env, mf_not_found, "db_set_active", _("No such db format: %s"),fmtid)
#line 303
;
	fmt->enabled = active;
}
}

void
#line 308
bi_db_expire_interval(eval_environ_t env)
#line 308

#line 308 "bi_db.m4"
{
#line 308
	
#line 308

#line 308

#line 308
char * fmtid = (char *) get_string_arg(env, 0);
#line 308
        
#line 308
        adjust_stack(env, 1);
#line 308

#line 308
	if (prog_trace_option & BUILTIN_MASK_db)
#line 308
		prog_trace(env, "db_expire_interval %s",fmtid);;
#line 308

{
	struct db_format *fmt = db_format_lookup(fmtid);
		if (!(fmt != NULL))
#line 311
			env_throw_bi(env, mf_not_found, "db_expire_interval", _("No such db format: %s"),fmtid)
#line 313
;
	
#line 314
do {
#line 314
  push(env, (STKVAL) (fmt->expire_interval));
#line 314
  return;
#line 314
} while (0);
}
}


#line 318
void
#line 318
db_init_builtin()
#line 318
{
#line 318
	#line 68 "bi_db.m4"
va_builtin_install_ex("dbmap", bi_dbmap, 0, 0, dtype_number, 3, 1, 0, dtype_string, dtype_string, dtype_number);
#line 76 "bi_db.m4"
va_builtin_install_ex("dbget", bi_dbget, 0, 0, dtype_string, 4, 2, 0, dtype_string, dtype_string, dtype_string, dtype_number);
#line 85 "bi_db.m4"
va_builtin_install_ex("dbput", bi_dbput, 0, 0, dtype_unspecified, 4, 1, 0, dtype_string, dtype_string, dtype_string, dtype_number);
#line 120 "bi_db.m4"
va_builtin_install_ex("dbdel", bi_dbdel, 0, 0, dtype_unspecified, 3, 1, 0, dtype_string, dtype_string, dtype_number);
#line 177 "bi_db.m4"
	greylist_seconds_left_loc = builtin_variable_install("greylist_seconds_left", dtype_number, VAR_VOLATILE)->off;
#line 184 "bi_db.m4"
va_builtin_install_ex("greylist", bi_greylist, 0, 0, dtype_number, 2, 0, 0, dtype_string, dtype_number);
#line 278 "bi_db.m4"
va_builtin_install_ex("db_name", bi_db_name, 0, 0, dtype_string, 1, 0, 0, dtype_string);
#line 288 "bi_db.m4"
va_builtin_install_ex("db_get_active", bi_db_get_active, 0, 0, dtype_number, 1, 0, 0, dtype_string);
#line 298 "bi_db.m4"
va_builtin_install_ex("db_set_active", bi_db_set_active, 0, 0, dtype_unspecified, 2, 0, 0, dtype_string, dtype_number);
#line 308 "bi_db.m4"
va_builtin_install_ex("db_expire_interval", bi_db_expire_interval, 0, 0, dtype_number, 1, 0, 0, dtype_string);

#line 318 "bi_db.m4"
		
#line 318
}

#line 547 "../src/snarf.m4"

#line 547

